type DataOutputStream = {
    with OutputStream
    def flush: ()
    def writeInt(n: int): ()
    def writeFloat(x: float): ()
    def writeUTF(str: string): ()
}

newtype DataOutputStreamModule = {
    def create(funnelstream: OutputStream): DataOutputStream
    def new(javastream: any): DataOutputStream
    def extend(funnelstream: OutputStream, javastream: any): DataOutputStream
}

let DataOutputStream: DataOutputStreamModule = {
    def create(stream) = {
        val newstream =
	    primitive (0, "java.io.OutputStream", "<init>", "()V") ()
        extend(OutputStream.new(newstream), newstream)
    }
    def new(out) = extend(OutputStream.new(out), out)
    def extend(stream, out) = {
        with stream
        def flush = primtive (2, "java.io.DataOutputStream", "flush", "()V") (out)
        def writeInt(n) =
	    primtive (2, "java.io.DataOutputStream", "writeInt", "(I)V") (out, n)
        def writeFloat(x) =
	    primtive (2, "java.io.DataOutputStream", "writeFloat", "(F)V") (out, x)
        def writeUTF(str) =
	    primtive (2,
		      "java.io.DataOutputStream",
		      "writeFloat",
		      "(Ljava/lang/String;)V")
		     (out, x)
    }
}
