type InputStream = {
    def available: int
    def close: ()
    def mark(x: int): ()
    def markSupported: boolean
    def read: int
    def reset: ()
    def toJava: any
}

newtype InputStreamModule = {
    def new(javastream: any): InputStream
}

let InputStream: InputStreamModule = {
    def new(self) = {
        def available =
	    primitive (2, "java.io.inputStream", "available", "()I") (self)
        def close =
	    primitive (2, "java.io.inputStream", "close", "()V") (self)
        def mark (x: int) =
	    primitive (2, "java.io.inputStream", "mark", "(I)V") (self, x)
        def markSupported =
	    primitive (2, "java.io.inputStream", "markSupported", "()Z") (self)
        def read =
	    primitive (2, "java.io.inputStream", "read", "()I") (self)	    
        def reset =
	    primitive (2, "java.io.inputStream", "reset", "()V") (self)	    
        val toJava = self
    }
}
