type Socket = {
    def close: ()
    def getInetAddress: InetAddress
    def getInputStream: InputStream
    def getLocalPort: int
    def getOutputStream: OutputStream
    def getPort: int
    def toString: string
    def toJava: any
}

newtype SocketModule = {
    def create(host: string, port: int): Socket
}

let Socket: SocketModule = {
    def create(host, port) = {
	val self =
	    primitive (0, "java.net.Socket", "<init>", "(Ljava/lang/String;I)V")
		      (host, port)
        def close = primitive (2, "java.net.Socket", "close", "()V") (self)
        def getInetAddress =
	    InetAddress.new(primitive (2,
				       "java.net.Socket",
				       "getInetAddress",
				       "()Ljava/net/InetAddress;")
                                      (self))
        def getInputStream =
	    InputStream.new(primitive (2,
				       "java.net.Socket",
				       "getInputStream",
				       "()Ljava/io/InputStream;")
				      (self))
        def getLocalPort =
	    primitive (2, "java.net.Socket", "getLocalPort", "()I") (self)
        def getOutputStream =
	    OutputStream.new(primitive (2,
				       "java.net.Socket",
				       "getOutputStream",
				       "()Ljava/io/OutputStream;")
				      (self))
        def getPort = primitive (2, "java.net.Socket", "getPort", "()I") (self)
        def toString = primitive (2,
				  "java.net.Socket",
				  "toString",
				  "()Ljava/lang/String;")
				 (self)
        val toJava = self
    }
}
